import { Component, OnInit, Input, Output } from '@angular/core';
import { EXT5 } from './ext5';

@Component({
  selector: 'app-ext5-barcode',
  templateUrl: './ext5-barcode.component.html',
  styleUrls: ['./ext5-barcode.component.css']
})
export class Ext5BarcodeComponent implements OnInit {
  barcode: string = "";
  barcode_text: string ="";

  @Input() data: string="12345678";
  @Input() checkDigit: boolean=true;

  constructor() { }

  ngOnInit() {
    var ext5=new EXT5(this.data);
    this.barcode=ext5.encode();
    this.barcode_text=ext5.connectcode_human_readable_text;
  }

}
