/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-code128c'

class Code128C extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCode128_S3_Trial;
      src: url("./src/components/fonts/ConnectCode128_S3_Trial.woff2") format("woff2");
    }      
    .Code128C {width: 5in}
    .barcode_code128c {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCode128_S3_Trial', sans-serif; font-size: 32px}
    .barcode_text_code128c {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 28px}

    </style>
    <div class='Code128C'>
      <center>	
        <div class='barcode_code128c'>${encode(this.input)}</div>	
        <div class='barcode_text_code128c'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String
    }
  }
}

customElements.define('barcode-code128c', Code128C);
