/*
 * ConnectCode
 *
 * Copyright (c) 2006-2019 ConnectCode Pte Ltd (https://www.barcoderesource.com)
 * All Rights Reserved.
 *
 * This source code is protected by International Copyright Laws. You are only allowed to modify
 * and include the source in your application if you have purchased a Distribution License.
 *
 * http://www.barcoderesource.com
 *
 */

import { LitElement, html } from 'lit-element';
import { encode, getText } from './js/connectcode-javascript-postnet'

class POSTNET extends LitElement {
  constructor() {
    super();
    this.input = '12345678';
  }

  render() {
    return html`
    <style>
    @font-face {
      font-family: CCodePostnet_Trial;
      src: url("./fonts/ConnectCodePostnet_Trial.woff2") format("woff2");
    }      
    .POSTNET {width: 5in}
    .barcode_postnet {font-weight: normal; font-style: normal; line-height:normal; font-family: 'CCodePostnet_Trial', sans-serif; font-size: 12px}
    .barcode_text_postnet {font-weight: normal; font-style: normal; line-height:normal; font-family: sans-serif; font-size: 18px}

    </style>
    <div class='POSTNET'>
      <center>	
        <div class='barcode_postnet'>${encode(this.input)}</div>	
        <div class='barcode_text_postnet'>${getText()}</div>	
      </center>
      </div>
`;
  }

  static get properties() {
    return {
      input: String
    }
  }
}

customElements.define('barcode-postnet', POSTNET);
