-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.Code128CUNICHR(@DataNum  int )
  RETURNS nvarchar(20)
  AS
  BEGIN
      DECLARE @ReturnString nvarchar(20);
	  SET @ReturnString='';
	  IF @DataNum>=191 and @DataNum<=199  
		   SET @ReturnString = nchar(@DataNum);
	  ELSE IF @DataNum>=227 and @DataNum<=238
		   SET @ReturnString = nchar(@DataNum);
      ELSE
		   SET @ReturnString = CHAR(@DataNum);

      RETURN(@ReturnString);
  END
GO

CREATE OR ALTER FUNCTION dbo.EncodeCode128C( @InputData nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(2);
	  DECLARE @Weight int;
      DECLARE @Sumvalue int;
      DECLARE @Onevalue int;
      DECLARE @Chkvalue int;
	  DECLARE @CD nvarchar(2);
      DECLARE @FilteredData nvarchar(255);
      DECLARE @ReturnData nvarchar(560); 
	  DECLARE @FilteredLength int;
	  DECLARE @Counter int;

      SET @Weight = 1;
      SET @Sumvalue = 0;
      SET @Onevalue = 0;
      SET @Chkvalue = 0;
	  SET @FilteredData='';
	  SET @ReturnData='';
	  SET @FilteredLength = LEN(@InputData);
      SET @Counter = 1;

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @ReturnData = ''; 
		  RETURN(@ReturnData);
	  END

	  WHILE @Counter <= @FilteredLength
	  BEGIN

		SET @TempChar = SUBSTRING(@InputData,@Counter,1);
		SET @Onevalue = ASCII(@TempChar);
		IF @Onevalue >= 48 AND @Onevalue <=57  
			SET @FilteredData = @FilteredData + @TempChar;
        SET @Counter=@Counter+1;
      END

    SET @FilteredLength = LEN(@FilteredData);	
    IF @FilteredLength > 253 
		SET @FilteredData = SUBSTRING(@FilteredData,1,253);

    SET @FilteredLength = LEN(@FilteredData);	
    IF @FilteredLength % 2 = 1 
		SET @FilteredData = '0' + @FilteredData;
    SET @Sumvalue=105;
	SET @FilteredLength = LEN(@FilteredData);	
    IF @FilteredLength IS NULL 
		RETURN '';

	SET @Counter = 1;

	SET @Onevalue = CAST('12' AS INT);
	WHILE @Counter <= @FilteredLength
	BEGIN
		IF @Counter % 2 = 1 
		BEGIN
		  SET @TempChar = SUBSTRING(@FilteredData,@Counter,2);
		  SET @Onevalue = CAST(@TempChar AS INT);
		  SET @Chkvalue = @Onevalue;
		  SET @Sumvalue = @Sumvalue + (@Chkvalue * @Weight);
		  SET @Weight = @Weight + 1;
		  IF @Onevalue <= 94 AND @Onevalue >= 0 
			SET @ReturnData = @ReturnData + dbo.Code128CUNICHR(@Onevalue+32);
		  ELSE IF @Onevalue <= 106 AND @Onevalue >= 95 
			SET @ReturnData = @ReturnData + dbo.Code128CUNICHR(@Onevalue+100+32);
		  ELSE
			SET @ReturnData = @ReturnData;
      
		END 
		SET @Counter=@Counter+1;
    END
	
	
	SET @FilteredData=@ReturnData;
	
	SET @Sumvalue = @Sumvalue % 103;
    IF @Sumvalue <= 94 AND @Sumvalue >= 0
		SET @CD = dbo.UNICHRX(@Sumvalue+32);
    ELSE IF @Sumvalue <= 106 AND @Sumvalue >= 95
		SET @CD = dbo.UNICHRX(@Sumvalue+100+32);
    ELSE
		SET @CD = '';

    SET @ReturnData = dbo.Code128CUNICHR(237) + @FilteredData + @CD + dbo.Code128CUNICHR(238);
    RETURN(@ReturnData);
  END
GO