-- Copyright 2006-2020 ConnectCode Pte Ltd. All Rights Reserved.
-- This source code is protected by Copyright Laws. You are only allowed to modify
-- and include the source in your application if you have purchased a Distribution License.
-- ===================================================================================
-- ConnectCode Barcode TSQL UDF for SQL Server
--
-- The formulas in this file can be used for creating barcodes in Microsoft SQL SErver.

CREATE OR ALTER FUNCTION dbo.generateEAN13CheckDigit(@Data nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN
   DECLARE @Datalength int=LEN(@Data);
   DECLARE @Parity int=0; 
   DECLARE @Sumvalue int=0;
   DECLARE @Resultvalue int=-1;
   DECLARE @StrResult nvarchar(30)='';
   DECLARE @Barcodechar nvarchar(1)='';
   DECLARE @Barcodevalue int=0;
   DECLARE @X int=LEN(@Data);

   While @X >=1
   BEGIN
    SET @Barcodechar=SUBSTRING(@Data,@X,1);
	SET @Barcodevalue=ASCII(@Barcodechar);
	SET @Barcodevalue=@Barcodevalue - 48;
	IF @X % 2=0 
		SET @Sumvalue = @Sumvalue + (3*@Barcodevalue);
	ELSE
		SET @Sumvalue = @Sumvalue + @Barcodevalue;	
    SET @X=@X-1; 
   END

   SET @Resultvalue = @Sumvalue % 10;
   IF @Resultvalue = 0 
	SET @Resultvalue = 0;
   ELSE
	SET @Resultvalue = 10 - @Resultvalue;

   SET @Resultvalue = @Resultvalue+48;	
   SET @StrResult=@StrResult + CHAR(@Resultvalue);
 
   RETURN @StrResult;
  END
  GO

CREATE OR ALTER FUNCTION dbo.getEAN13PARITYMAP(@Digit1 int, @Digit2 int)
  RETURNS int
  AS
  BEGIN
	IF @Digit1=0 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=4 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=5 
		RETURN 0;

	IF @Digit1=1 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=1 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=4 
		RETURN 1;
	ELSE IF @Digit1=1 AND @Digit2=5 
		RETURN 1;

	IF @Digit1=2 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=2 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=2 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=4 
		RETURN 0;
	ELSE IF @Digit1=2 AND @Digit2=5 
		RETURN 1;

	IF @Digit1=3 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=3 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=3 AND @Digit2=4 
		RETURN 1;
	ELSE IF @Digit1=3 AND @Digit2=5 
		RETURN 0;

	IF @Digit1=4 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=4 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=4 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=4 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=4 AND @Digit2=4 
		RETURN 1;
	ELSE IF @Digit1=4 AND @Digit2=5 
		RETURN 1;

	IF @Digit1=5 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=5 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=5 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=5 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=5 AND @Digit2=4 
		RETURN 0;
	ELSE IF @Digit1=5 AND @Digit2=5 
		RETURN 1;

	IF @Digit1=6 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=6 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=6 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=6 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=6 AND @Digit2=4 
		RETURN 0;
	ELSE IF @Digit1=6 AND @Digit2=5 
		RETURN 0;

	IF @Digit1=7 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=7 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=7 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=7 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=7 AND @Digit2=4 
		RETURN 0;
	ELSE IF @Digit1=7 AND @Digit2=5 
		RETURN 1;

	IF @Digit1=8 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=8 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=8 AND @Digit2=2 
		RETURN 0;
	ELSE IF @Digit1=8 AND @Digit2=3 
		RETURN 1;
	ELSE IF @Digit1=8 AND @Digit2=4 
		RETURN 1;
	ELSE IF @Digit1=8 AND @Digit2=5 
		RETURN 0;

	IF @Digit1=9 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=9 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=9 AND @Digit2=2 
		RETURN 1;
	ELSE IF @Digit1=9 AND @Digit2=3 
		RETURN 0;
	ELSE IF @Digit1=9 AND @Digit2=4 
		RETURN 1;
	ELSE IF @Digit1=9 AND @Digit2=5 
		RETURN 0;

	RETURN 0;
  END
Go

CREATE OR ALTER FUNCTION dbo.EncodeEAN13( @InputData nvarchar(255), @Hr int )
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(1);
	  DECLARE @Transformchar nvarchar(1);
	  DECLARE @Weight int=1;
	  DECLARE @Transformvalue int=0;
	  DECLARE @SumValue int=0;
	  DECLARE @OneValue int=0;
	  DECLARE @ChkValue int=0;
	  DECLARE @Lendiff int=0;
	  DECLARE @CD char;
      DECLARE @FilteredData nvarchar(255)='';
      DECLARE @ReturnData nvarchar(255)=''; 
      DECLARE @ResultData nvarchar(255)=''; 
	  DECLARE @FilteredLength int=LEN(@InputData);	  
   	  DECLARE @Paritybit    int=0;
   	  DECLARE @Firstdigit   int=0; 
   	  DECLARE @Datalength   int=0;
   	  DECLARE @Transformdataleft nvarchar(255)='';
   	  DECLARE @Transformdataright nvarchar(255)='';

	  DECLARE @Counter int;
	  DECLARE @X int;

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @ReturnData = ''; 
		  RETURN(@ReturnData);
	  END
      SET @Counter = 1;
	  While @Counter<=@FilteredLength
	  BEGIN
			SET @TempChar = SUBSTRING(@InputData,@Counter,1);
			SET @OneValue = ASCII(@TempChar);
			IF @OneValue >= 48 AND @OneValue <=57 
				SET @FilteredData = @FilteredData + @TempChar;
	        SET @Counter = @Counter+1;
	  END
	     SET @FilteredLength = LEN(@FilteredData);	

	  IF @FilteredLength <= 0 
	  BEGIN
	      SET @ReturnData = ''; 
		  RETURN(@ReturnData);
	  END
	  
   SET @FilteredLength = LEN(@FilteredData);	
   IF @FilteredLength > 12 
    SET @FilteredData = SUBSTRING(@FilteredData,1,12);

   SET @FilteredLength = LEN(@FilteredData);	
   IF @FilteredLength < 12
   BEGIN
	SET @Lendiff=12-@FilteredLength;
	SET @Counter = 1;
	While @Counter<=@Lendiff
	BEGIN
	    SET @FilteredData = '0' + @FilteredData;	
		SET @Counter = @Counter+1;
	END
   END


   SET @CD=dbo.generateEAN13CheckDigit(@FilteredData);
   SET @FilteredData=@FilteredData+@CD;

   SET @X = 1;
   While @X<=7
   BEGIN
  		IF @X=1 
			SET @Firstdigit=ASCII(SUBSTRING(@FilteredData,@X,1))-48; 
		ELSE
		BEGIN
			SET @Paritybit=dbo.getEAN13PARITYMAP(@Firstdigit,@X-2);
			IF @Paritybit=0
				SET @Transformdataleft=@Transformdataleft + SUBSTRING(@FilteredData,@X,1);
			ELSE
				SET @Transformdataleft=@Transformdataleft + CHAR(ASCII(SUBSTRING(@FilteredData,@X,1)) + 49 + 14);				
		END
	    SET @X = @X+1;   
   END

   SET @X = 8;
   While @X<=13
   BEGIN
	SET @Transformchar=SUBSTRING(@FilteredData,@X,1);
	SET @Transformvalue=ASCII(@Transformchar)+49; 
	SET @Transformdataright=@Transformdataright+CHAR(@Transformvalue);
	SET @X = @X+1;   
   END 	   
   	
   IF @Hr=1
		SET @ResultData=CHAR(@Firstdigit+33) + '[' + @Transformdataleft + '-' + @Transformdataright + ']';
   ELSE
		SET @ResultData='[' + @Transformdataleft + '-' + @Transformdataright + ']';
  
   RETURN @ResultData;

  END
GO