CREATE OR ALTER FUNCTION dbo.getEXT2PARITYMAP(@Digit1 int, @Digit2 int)
  RETURNS int
  AS
  BEGIN

	IF @Digit1=0 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=0 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=0 
		RETURN 0;
	ELSE IF @Digit1=1 AND @Digit2=1 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=2 AND @Digit2=1 
		RETURN 0;
	ELSE IF @Digit1=3 AND @Digit2=0 
		RETURN 1;
	ELSE IF @Digit1=3 AND @Digit2=1 
		RETURN 1;

	RETURN 0;
  END
Go

CREATE OR ALTER FUNCTION dbo.EncodeEXT2( @InputData nvarchar(255))
  RETURNS nvarchar(255)
  AS
  BEGIN    
	  DECLARE @TempChar nvarchar(1);
	  DECLARE @Transformchar nvarchar(1);
	  DECLARE @Transformvalue int=0;
	  DECLARE @SumValue int=0;
	  DECLARE @OneValue int=0;
	  DECLARE @Value1 int=0;
	  DECLARE @Value2 int=0;
	  DECLARE @Lendiff int=0;
      DECLARE @FilteredData nvarchar(255)='';
      DECLARE @ResultData nvarchar(255)=''; 
	  DECLARE @FilteredLength int=LEN(@InputData);	  
   	  DECLARE @Parityindex    int=0;
   	  DECLARE @Paritybit    int=0;
   	  DECLARE @Datalength   int=0;
   	  DECLARE @Transformdataleft nvarchar(255)='';
   	  DECLARE @Transformdataright nvarchar(255)='';

	  DECLARE @Counter int;
	  DECLARE @X int;

	  IF @FilteredLength IS NULL 
	  BEGIN
		  RETURN('');
	  END

	  IF @FilteredLength <= 0 
	  BEGIN
		  RETURN('');
	  END

      SET @Counter = 1;
	  While @Counter<=@FilteredLength
	  BEGIN
			SET @TempChar = SUBSTRING(@InputData,@Counter,1);
			SET @OneValue = ASCII(@TempChar);
			IF @OneValue >= 48 AND @OneValue <=57 
				SET @FilteredData = @FilteredData + @TempChar;
	        SET @Counter = @Counter+1;
	  END
	  SET @FilteredLength = LEN(@FilteredData);	
	  IF @FilteredLength IS NULL 
	  BEGIN
		  RETURN('');
	  END

	  IF @FilteredLength <= 0 
	  BEGIN
		  RETURN('');
	  END
	  
	   SET @FilteredLength = LEN(@FilteredData);	
	   IF @FilteredLength > 2 
		SET @FilteredData = SUBSTRING(@FilteredData,1,7);

	   SET @FilteredLength = LEN(@FilteredData);	
	   IF @FilteredLength < 2
	   BEGIN
		SET @Lendiff=2-@FilteredLength;
		SET @Counter = 1;
		While @Counter<=@Lendiff
		BEGIN
			SET @FilteredData = '0' + @FilteredData;	
			SET @Counter = @Counter+1;
		END
	   END

	   SET @Sumvalue=0;
	   SET @Value1=0;
	   SET @Value2=0;
	   SET @Parityindex=0;

	   SET @Value1=(ASCII(SUBSTRING(@FilteredData,1,1)) -48) * 10;
       SET @Value2=ASCII(SUBSTRING(@FilteredData,2,1)) -48;
       SET @SumValue = @Value1 + @Value2;
       SET @Parityindex = @SumValue % 4;

       SET @Datalength=LEN(@FilteredData);
       SET @Paritybit=0;
       SET @Paritybit=dbo.getEXT2PARITYMAP(@Parityindex,0);
       IF @Paritybit=0 
	     SET @Transformdataleft=@Transformdataleft+SUBSTRING(@Filtereddata,1,1);
       ELSE
	     SET @Transformdataleft=@Transformdataleft+CHAR(ASCII(SUBSTRING(@FilteredData,1,1))+49+14);

       SET @Paritybit=dbo.getEXT2PARITYMAP(@Parityindex,1);
	   IF @Paritybit=0 
		SET @Transformdataright=@Transformdataright+SUBSTRING(@Filtereddata,2,1);
	   ELSE
		SET @Transformdataright=@Transformdataright+CHAR(ASCII(SUBSTRING(@Filtereddata,2,1))+49+14);

       SET @Resultdata='<' + @Transformdataleft + '+' + @Transformdataright;
   	  
	   RETURN @ResultData;

  END
GO